
function [y] = Forwsub(L,b)

%___________________________________________________________________
%
% Funzione: Forwsub
%_____________________
%
% Chiamata:  [y] = Forwsub(L,b);
%
% La function 'Forwsub' risolve il sistema Ly=b, con L matrice 
% triangolare inferiore e non singolare, attraverso il metodo 
% delle sostituzioni in avanti.
%
% Parametri in ingresso:
% ______________________
%
%  L   matrice del sistema, di dimensione nxn, triangolare inferiore 
%      e non singolare;
%  b   vettore colonna, di lunghezza n, contente il termine noto 
%      del sistema;
%
% Parametri in uscita:
% ____________________
%
%  y   vettore di lunghezza n, contenente la soluzione del sistema.
%
%___________________________________________________________________

n=length(b);
if prod(abs(diag(L)))<1e-14
   disp('Matrice U singolare');
   y=[];
else
   y(1)=b(1)/L(1,1);
   for i=2:n
      y(i)=(b(i)-L(i,1:i-1)*(y(1:i-1))')/L(i,i);
   end
   y=y';
end
