
function [L,U] = Lufact(A)

%______________________________________________________________
%
% Funzione: Lufact
% ___________________
%
% Chiamata:  [L,U] = Lufact(A);
%
% La function 'Lufact' esegue la fattorizzazione LU della matrice 
% A, senza pivotazione.
% E' utile, ad esempio, nel caso in cui A sia simmetrica e 
% definita positiva.
%
%            A=LU
%
%
% Parametri in ingresso:
% ______________________
%
%   A    matrice di dimensione nxn da fattorizzare;
%
% Parametri in uscita:
% ____________________
%
%   L     matrice triangolare inferiore di dimensione nxn;
%   U     matrice triangolare superiore di dimensione nxn;
%
%______________________________________________________________

a=A;
if abs(det(a))<10^-14
   disp('Matrice A singolare')
else
   [n,m]=size(a);
   for k=1:m-1
%      
%   Azzeramento degli elementi a(i,k)
%
      for i=k+1:n
         mik=-a(i,k)/a(k,k);
		   a(i,k)=-mik;
		   for j=k+1:n
   			a(i,j)=a(i,j)+mik*a(k,j);
	   	end
	   end
      
   end             
%
%   Costruzione delle matrici L, U
%
   L=tril(a,-1)+eye(n);
   U=triu(a);
end
